<?php
/**
 * @file
 * Token integration for the Commerce Event Ticket PDF module.
 */

/**
 * Implements hook_token_info().
 */
function commerce_event_ticket_pdf_token_info() {
  $info = array();
  $info['tokens'] = array(
    'commerce-event-ticket' => array(
      'ticket-pdf' => array(
        'name' => t('Ticket PDF'),
        'description' => t('The path to a PDF for this ticket.'),
      ),
    ),
    'commerce-order' => array(
      'ticket-pdf' => array(
        'name' => t('Ticket PDF'),
        'description' => t("The path to a PDF for this order's tickets."),
      ),
    ),
  );
  return $info;
}

/**
 * Implements hook_tokens().
 */
function commerce_event_ticket_pdf_tokens($type, array $tokens, array $data = array(), array $options = array()) {
  $sanitize = !empty($options['sanitize']);
  $replacements = array();
  if ($type == 'commerce-event-ticket' && !empty($data['commerce-event-ticket'])) {
    $ticket = $data['commerce-event-ticket'];
    foreach ($tokens as $name => $original) {
      switch ($name) {
        case 'ticket-pdf':
          $uri = commerce_event_ticket_pdf_get_link($ticket->ticket_id, 'commerce_event_ticket', 'view', FALSE);
          if ($uri) {
            $uri['absolute'] = TRUE;
            $replacements[$original] = l(t('Ticket PDF'), $uri['path'], $uri);
          }
          break;

      }
    }
  }
  elseif ($type == 'commerce-order' && !empty($data['commerce-order'])) {
    $order = $data['commerce-order'];
    foreach ($tokens as $name => $original) {
      switch ($name) {
        case 'ticket-pdf':
          $uri = commerce_event_ticket_pdf_get_link($order->order_id, 'commerce_order', 'view', FALSE);
          if ($uri) {
            $uri['absolute'] = TRUE;
            $count = count(commerce_event_ticket_create_from_order($order));
            $replacements[$original] = l(
              format_plural($count, 'Ticket (PDF)', 'Tickets (PDF)'),
              $uri['path'],
              $uri
            );
          }
          break;

      }
    }
  }
  return $replacements;
}
